from es import entitysetvalue, entitygetvalue, setplayerprop, setindexprop, fire, getplayerhandle, getindexfromhandle, createentity, addons
from gamethread import delayedname, cancelDelayed
from playerlib import getPlayer as pgetPlayer
from random import randint

__all__ = ['getPlayer']

moduleName = __import__(__name__)

class getPlayer(object):
    userid = 0
    settings = {}

    def __init__(self, userid):
        self.userid = str(userid)
        if not self.userid in players:
            players[self.userid] = {'gravity':1.0, 'drunk':False, 'regen':False}
        self.settings = players[self.userid]

    def __getattr__(self, attr):
        if hasattr(getPlayer, attr):
            return getattr(self, attr)

        else:
            try:
                return self.__getitem__(attr)

            except KeyError:
                raise AttributeError, attr

    def __setattr__(self, attr, value):
        if hasattr(getPlayer, attr):
            object.__setattr__(self, attr, value)

        else:
            try:
                self.__setitem__(attr, value)

            except KeyError:
                raise AttributeError, attr

    def __getitem__(self, attr):
        if attr == 'index':
            return self.getIndex()

        elif attr == 'gravity':
            return self.getGravity()

        elif attr == 'drunk':
            return self.getDrunk()

        elif attr == 'regen':
            return self.getRegen()

        raise KeyError, attr

    def __setitem__(self, attr, value):
        if attr == 'gravity':
            self.setGravity(value)

        elif attr == 'drunk':
            self.setDrunk(value)

        elif attr == 'regen':
            self.setRegen(value)

        else:
            raise KeyError, attr

    def getIndex(self):
        return getindexfromhandle(getplayerhandle(self.userid))

    def damagePlayer(self, damage, damagetype=32, userid=None, weapon='point_hurt'):
        if not userid:
            userid = self.userid

        index = str(self.getIndex())
        entity = createentity('point_hurt')
        entitysetvalue(entity, 'classname', weapon)
        entitysetvalue(entity, 'targetname', entity)
        entitysetvalue(entity, 'damage', damage)
        entitysetvalue(entity, 'damagetype', damagetype)
        entitysetvalue(entity, 'damagetarget', index)
        setindexprop(entity, 'CBaseEntity.m_hOwnerEntity', getplayerhandle(userid))
        fire(self.userid, '!self', 'addoutput', 'targetname ' + index)
        fire(userid, entity, 'Hurt')
        fire(userid, entity, 'Kill')
        fire(self.userid, '!self', 'addoutput', 'targetname ' + entitygetvalue(index, 'targetname'))

    def setGravity(self, amount):
        amount = round(float(amount), 2)
        self.settings['gravity'] = amount
        fire(self.userid, '!self', 'addoutput', 'gravity ' + str(amount))

    def getGravity(self):
        return self.settings['gravity']

    def setDrunk(self, value):
        if value:
            self.settings['drunk'] = True

        else:
            self.settings['drunk'] = False

    def getDrunk(self):
        return self.settings['drunk']

    def setRegen(self, value):
        if value:
            self.settings['regen'] = True

        else:
            self.settings['regen'] = False

    def getRegen(self):
        return self.settings['regen']

def repeatLoop():
    for userid in players:
        if players[userid]['drunk']:
            setplayerprop(userid, 'CBasePlayer.localdata.m_Local.m_vecPunchAngle', '0' + ',' + '0' + ',' + str(randint(-100, 100)))

        if players[userid]['regen']:
            player = pgetPlayer(userid)
            if player.health < 100:
                player.health += 1

    delayedname(1, '_superdice_repeat_loop', repeatLoop, ())

def player_jump(ev):
    player = getPlayer(ev['userid'])
    player.setGravity(player.getGravity())

def player_spawn(ev):
    player = getPlayer(ev['userid'])
    player.setGravity(1.0)
    player.setDrunk(False)
    player.setRegen(False)

def player_death(ev):
    player = getPlayer(ev['userid'])
    player.setDrunk(False)
    player.setRegen(False)

def es_map_start(ev):
    players.clear()
    cancelDelayed('_superdice_repeat_loop')
    repeatLoop()

addons.registerForEvent(moduleName, 'player_jump', player_jump)
addons.registerForEvent(moduleName, 'player_spawn', player_spawn)
addons.registerForEvent(moduleName, 'player_death', player_death)
addons.registerForEvent(moduleName, 'es_map_start', es_map_start)

players = {}

cancelDelayed('_superdice_repeat_loop')
repeatLoop()
